<h2 id="available-feature-flags">{{ T "featureFlags.mainHeading" }}</h2>

<p>{{ T "featureFlags.mainSubheading" }}:</p>
<ul>
  <li>{{ T "featureFlags.editionTxt" }}: <a href="https://about.gitlab.com/install/ce-or-ee/">{{ T "featureFlags.editionLinkTxt" }}</a>.</li>
  <li>{{ T "featureFlags.versionTxt" }}</li>
  <li>{{ T "featureFlags.installationTxt" }}</li>
</ul>

{{ $uniqueGroupsWithCounts := dict }}
{{ $uniqueMilestonesWithCounts := dict }}
{{ $products := .Site.Data.feature_flags.products}}

{{ $countDict := dict }}
{{ range $product, $flags :=  $products}}
  {{ $flagCount := 0 }}
  {{ range $flag := $flags }}
    {{ $flagCount = add $flagCount 1 }}
  {{ end }}
  {{ $countDict = merge $countDict (dict $product $flagCount) }}
{{ end }}

{{ range $product, $flags := $products }}
  <h3 id="{{ $product | lower | replaceRE "[[:space:]]" "-" }}">{{ $product }}</h3>
  <p>{{ index $countDict $product }} {{ T "featureFlags.availableTxt" }} {{ $product }}.</p>
  <table class="table-sortable feature-table">
    <thead>
      <tr>
        <th class="sortable" data-sort="string">{{ T "featureFlags.availableFFName" }}</th>
        <th class="sortable" data-sort="string">{{ T "featureFlags.availableFFGroup" }}</th>
        <th class="sortable" data-sort="number" data-default="desc">{{ T "featureFlags.availableFFMilestone" }}</th>
        <th class="sortable" data-sort="string">{{ T "featureFlags.availableFFDefaultState" }}</th>
        <th>{{ T "featureFlags.availableFFRolloutIssue" }}</th>
      </tr>
    </thead>
    <tbody>
      {{ range $flag := $flags }}
        {{ $group := default "Not defined" $flag.group }}
        {{ $milestone := default "Not defined" $flag.milestone }}
        {{ $defaultEnabled := eq $flag.default_enabled "true" }}

        <!-- Only set dict with enabled and disabled = 0 if unique group is not already in the dict -->
        {{ if not (isset $uniqueGroupsWithCounts $group ) }}
          {{ $uniqueGroupsWithCounts = merge $uniqueGroupsWithCounts (dict $group (dict "enabledCount" 0 "disabledCount" 0)) }}
        {{ end }}

        <!-- Only set dict with enabled and disabled = 0 if unique milestone is not already in the dict -->
        {{ if not (isset $uniqueMilestonesWithCounts $milestone ) }}
          {{ $uniqueMilestonesWithCounts = merge $uniqueMilestonesWithCounts (dict $milestone (dict "enabledCount" 0 "disabledCount" 0)) }}
        {{ end }}

        <!-- Grab current data for provided group and milestone -->
        {{ $groupCounts := index $uniqueGroupsWithCounts $group }}
        {{ $milestoneCounts := index $uniqueMilestonesWithCounts $milestone }}

        <!-- If enabled, increment enabledCount of both group and milestone counts -->
        {{ if $defaultEnabled }}
          {{ $groupCounts = merge $groupCounts (dict "enabledCount" (add $groupCounts.enabledCount 1)) }}
          {{ $milestoneCounts = merge $milestoneCounts (dict "enabledCount" (add $milestoneCounts.enabledCount 1)) }}
        {{ else }} <!-- If disabled, increment disabledCount of both group and milestone counts -->
          {{ $groupCounts = merge $groupCounts (dict "disabledCount" (add $groupCounts.disabledCount 1)) }}
          {{ $milestoneCounts = merge $milestoneCounts (dict "disabledCount" (add $milestoneCounts.disabledCount 1)) }}
        {{ end }}

        <!-- Update original dicts with new counts -->
        {{ $uniqueGroupsWithCounts = merge $uniqueGroupsWithCounts (dict $group $groupCounts) }}
        {{ $uniqueMilestonesWithCounts = merge $uniqueMilestonesWithCounts (dict $milestone $milestoneCounts) }}

        <tr>
          <td><code><a href="{{ $flag.introduced_by_url }}">{{ $flag.name }}</a></code></td>
          <td><code>{{ $group }}</code></td>
          <td>{{ $milestone }}</td>
          <td class="default-state-column">{{ if $defaultEnabled }}Enabled{{ else }}Disabled{{ end }}</td>
          <td class="rollout-issue-column">
            {{ if $flag.rollout_issue_url }}
              {{ $issueNum := index (last 1 (split $flag.rollout_issue_url "/")) 0 }}
              <a href="{{ $flag.rollout_issue_url }}">#{{ $issueNum }}</a>
            {{ else }}
              Not defined
            {{ end }}
          </td>
        </tr>
      {{ end }}
    </tbody>
  </table>
{{ end }}

<h2 id="ownership-by-group">{{ T "featureFlags.ownershipGrpsTitle" }}</h2>
<p>{{ T "featureFlags.ownershipGrpsSubtitle" }} <a href="https://handbook.gitlab.com/handbook/product/categories/">{{ T "featureFlags.ownershipGrpsEngineeringGrpLinkTxt" }}</a>.</p>

<table class="table-sortable ownership-by-groups">
  <thead>
    <tr>
      <th class="sortable" data-sort="string" data-default="asc">{{ T "featureFlags.ownershipGrpsGroup" }}</th>
      <th class="sortable" data-sort="number">{{ T "featureFlags.count" }}</th>
      <th class="sortable" data-sort="number">{{ T "featureFlags.enabled" }}</th>
      <th class="sortable" data-sort="number">{{ T "featureFlags.disabled" }}</th>
    </tr>
  </thead>
  <tbody>
  {{ range $k, $v := $uniqueGroupsWithCounts }}
    <tr>
      <td><code>{{ $k }}</code></td>
      {{ $totalCount := add (index $v "enabledCount") (index $v "disabledCount") }}
      <td>{{ $totalCount }}</td>
      <td>{{ index $v "enabledCount" }}</td>
      <td>{{ index $v "disabledCount" }}</td>
    </tr>
  {{ end }}
  </tbody>
</table>

<h2 id="count-by-milestone">{{ T "featureFlags.countMilestoneTitle" }}</h2>
<p>{{ T "featureFlags.countMilestoneSubtitle" }} <a href="https://handbook.gitlab.com/handbook/engineering/releases/">{{ T "featureFlags.countMilestoneDeliveredLinkTxt" }}</a>:</p>
<ul>
  <li>{{ T "featureFlags.countMilestoneSaasTxt" }}</li>
  <li>{{ T "featureFlags.countMilestoneEveryMonthReleaseTxt" }} <a href="https://about.gitlab.com/releases/">{{ T "featureFlags.countMilestoneEveryMonthReleaseLink" }}</a> {{T "featureFlags.countMilestoneEveryMonthReleaseProductTxt" }}</li>
</ul>

<table class="table-sortable count-by-milestone">
  <thead>
    <tr>
      <th class="sortable" data-sort="number" data-default="desc">{{ T "featureFlags.availableFFMilestone" }}</th>
      <th class="sortable" data-sort="number">{{ T "featureFlags.count" }}</th>
      <th class="sortable" data-sort="number">{{ T "featureFlags.enabled" }}</th>
      <th class="sortable" data-sort="number">{{ T "featureFlags.disabled" }}</th>
    </tr>
  </thead>
  <tbody>
  {{ range $milestone, $data := $uniqueMilestonesWithCounts }}
    <tr>
      <td>{{ $milestone }}</td>
      {{ $totalCount := add (index $data "enabledCount") (index $data "disabledCount") }}
      <td>{{ $totalCount }}</td>
      <td>{{ index $data "enabledCount" }}</td>
      <td>{{ index $data "disabledCount" }}</td>
    </tr>
  {{ end }}
  </tbody>
</table>
